Attribute VB_Name = "mdlGame"
' ****************************   (  ) :)

Public Type RECT
  left As Long
  top As Long
  right As Long
  bottom As Long
End Type

Public Type POINTAPI
  x As Long
  y As Long
End Type

Public Type BITMAP
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
End Type

Public Type UPOS
    uLine As Integer
    uColumn As Integer
End Type

' ****************************  ******************************
Public Const WM_NCLBUTTONDOWN = &HA1
Public Const HTCAPTION = 2

Public Const LWA_ALPHA          As Long = &H2
Public Const GWL_EXSTYLE        As Long = (-20)
Public Const WS_EX_LAYERED      As Long = &H80000
Public Const OBM_RESTORE        As Long = 32747

Public Const KING               As Long = 1
Public Const QUEEN              As Long = 2
Public Const OFICER             As Long = 3
Public Const HORSE              As Long = 4
Public Const PAWN               As Long = 5
Public Const CASTLE             As Long = 6

Public Const BM                 As String = "BLACK_MASK"
Public Const CB                 As String = "CASTLE_BLACK"
Public Const CW                 As String = "CASTLE_WITE"
Public Const KB                 As String = "KING_BLACK"
Public Const KW                 As String = "KING_WITE"
Public Const HB                 As String = "HORSE_BLACK"
Public Const HW                 As String = "HORSE_WITE"
Public Const OB                 As String = "O_BLACK"
Public Const OW                 As String = "O_WITE"
Public Const PB                 As String = "PAWN_BLACK"
Public Const PW                 As String = "PAWN_WITE"
Public Const QB                 As String = "QUEEN_BLACK"
Public Const QW                 As String = "QUEEN_WITE"
Public Const WM                 As String = "WITE_MASK"
Public Const SM                 As String = "SEL_MASK"
Public Const DK                 As String = "DESK"

Public Const U_WITE             As Long = 10
Public Const U_BLACK            As Long = 11


'***************************   Win32API ********************************

Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, _
    ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function ReleaseCapture Lib "user32" () As Long

Public Declare Function SetLayeredWindowAttributes Lib "user32" (ByVal hWnd As Long, ByVal crKey As Long, ByVal bAlpha As Byte, ByVal dwFlags As Long) As Long
Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function GetWindowRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Public Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Public Declare Function TransparentBlt Lib "msimg32.dll" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal crTransparent As Long) As Boolean
Public Declare Function LoadBitmap Lib "user32" Alias "LoadBitmapA" (ByVal hInstance As Long, ByVal lpBitmapName As String) As Long
Public Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Public Declare Function GetObjectAPI Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Public Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Public Declare Function CreateCompatibleBitmap Lib "gdi32" ( _
          ByVal hdc As Long, _
          ByVal nWidth As Long, _
          ByVal nHeight As Long) As Long

'   

Public Pice(64) As RECT '
Public PUnit(32) As CChessUnit ' 
Public CDesk(8, 8) As Boolean ' 
'***********************************!!!  !!!****************************

'    :) !!!
Public Function SetAlfa(fhwnd As Long, Optional sValue As Byte = 200)

    Dim ret As Long
    
'   Layered
ret = GetWindowLong(fhwnd, GWL_EXSTYLE)
ret = ret Or WS_EX_LAYERED
SetWindowLong fhwnd, GWL_EXSTYLE, ret

'   
SetLayeredWindowAttributes fhwnd, 0, sValue, LWA_ALPHA


End Function
'    ,   .
Public Function GetDesk(fhwnd As Long) As RECT

  Dim winrect As RECT  '   
  Dim retval As Long  '  

   '  winrect    Form1
  retval = GetWindowRect(Form1.hWnd, winrect)
   GetDesk = winrect
 
End Function
'          
Public Function PutUnit(frm As Form, Position As RECT, ResUnitName As String)


 Dim bmp As BITMAP
  Dim mem_bm As Long
  Dim mem_dc As Long
  Dim orig_bm As Long
  Dim x As Long
  Dim y As Long
   
   x = Screen.TwipsPerPixelX
   y = Screen.TwipsPerPixelY
   
     mem_dc = CreateCompatibleDC(mem_bm)
     '    
     mem_bm = LoadBitmap(App.hInstance, ResUnitName)
    
    '      
     orig_bm = SelectObject(mem_dc, mem_bm)
        
     '     
     GetObjectAPI mem_bm, Len(bmp), bmp
     
     'Me.
     TransparentBlt frm.hdc, Position.left \ x, Position.top \ x, _
     (Position.right - Position.left) \ x, (Position.bottom - Position.top) \ y, _
      mem_dc, 0, 0, bmp.bmWidth, bmp.bmHeight, vbWhite
      frm.Refresh
      '   
      SelectObject mem_dc, orig_bm
     '    
     '     ,
     '     
       DeleteObject mem_bm

End Function
'       ''      .
'      :)
'        .
Public Function PosToIndex(up As UPOS) As Integer

     PosToIndex = (up.uLine - 1) * 8 + (((up.uColumn - 1) Mod 8))
End Function

Public Function IndexToPos(ByVal index As Integer) As UPOS
 Dim retval As UPOS
  '      .
  retval.uLine = (index \ 8) + 1
  retval.uColumn = 1 + ((index) Mod 8)
    IndexToPos = retval
End Function
'.........................................................................




'      .  .
Public Function InitDesk(frm As Form, Side As Boolean)
  Dim i As Integer
    Dim j As Integer
    Dim k As Integer
    Dim pih As Long
    Dim Piw As Long
    Dim u As UPOS
   ' SetAlfa Me.hwnd
    pih = frm.Height \ 8
    Piw = frm.Width \ 8
     For i = 0 To 31
      Set PUnit(i) = New CChessUnit
     Next i
       
       
       
    For i = 0 To 7
      For j = 0 To 7
        Pice(k).left = (Piw + 1) * j
        Pice(k).right = Pice(k).left + Piw + 1
        Pice(k).top = (pih + 1) * i
        Pice(k).bottom = Pice(k).top + pih + 1
         'Debug.Print k; Pice(k).left; Pice(k).right; Pice(k).top; Pice(k).bottom
        
        k = k + 1
      Next j
     
    Next i
      
       For i = 0 To 7
         '    .
         CDesk(0, i) = True: CDesk(1, i) = True
         CDesk(6, i) = True: CDesk(7, i) = True
        
       Next i
       
       
       
       
  If Side Then
     PutUnit frm, Pice(0), CB
      PUnit(0).SetUnitPos IndexToPos(0).uLine, IndexToPos(0).uColumn
      PUnit(0).SetUnit U_BLACK, CASTLE
     
     PutUnit frm, Pice(1), HB
      PUnit(1).SetUnitPos IndexToPos(1).uLine, IndexToPos(1).uColumn
      PUnit(1).SetUnit U_BLACK, HORSE
     
     PutUnit frm, Pice(2), OB
      PUnit(2).SetUnitPos IndexToPos(2).uLine, IndexToPos(2).uColumn
      PUnit(2).SetUnit U_BLACK, OFICER
     
     PutUnit frm, Pice(3), QB
      PUnit(3).SetUnitPos IndexToPos(3).uLine, IndexToPos(3).uColumn
      PUnit(3).SetUnit U_BLACK, QUEEN
     
     PutUnit frm, Pice(4), KB
      PUnit(4).SetUnitPos IndexToPos(4).uLine, IndexToPos(4).uColumn
      PUnit(4).SetUnit U_BLACK, KING
     
     PutUnit frm, Pice(5), OB
      PUnit(5).SetUnitPos IndexToPos(5).uLine, IndexToPos(5).uColumn
      PUnit(5).SetUnit U_BLACK, OFICER
     
     PutUnit frm, Pice(6), HB
      PUnit(6).SetUnitPos IndexToPos(6).uLine, IndexToPos(6).uColumn
      PUnit(6).SetUnit U_BLACK, HORSE
     
     PutUnit frm, Pice(7), CB
      PUnit(7).SetUnitPos IndexToPos(7).uLine, IndexToPos(7).uColumn
      PUnit(7).SetUnit U_BLACK, CASTLE
       
       For i = 8 To 15
        PUnit(i).SetUnitPos IndexToPos(i).uLine, IndexToPos(i).uColumn
        PUnit(i).SetUnit U_BLACK, PAWN
        PutUnit frm, Pice(i), PB
       Next i
       
       
       
     PutUnit frm, Pice(56), CW
      PUnit(16).SetUnitPos IndexToPos(56).uLine, IndexToPos(56).uColumn
      PUnit(16).SetUnit U_WITE, CASTLE
     
     PutUnit frm, Pice(57), HW
      PUnit(17).SetUnitPos IndexToPos(57).uLine, IndexToPos(57).uColumn
      PUnit(17).SetUnit U_WITE, HORSE
     
     PutUnit frm, Pice(58), OW
      PUnit(18).SetUnitPos IndexToPos(58).uLine, IndexToPos(58).uColumn
      PUnit(18).SetUnit U_WITE, OFICER
     
     PutUnit frm, Pice(59), QW
      PUnit(19).SetUnitPos IndexToPos(59).uLine, IndexToPos(59).uColumn
      PUnit(19).SetUnit U_WITE, QUEEN
     
     PutUnit frm, Pice(60), KW
      PUnit(20).SetUnitPos IndexToPos(60).uLine, IndexToPos(60).uColumn
      PUnit(20).SetUnit U_WITE, KING
     
     PutUnit frm, Pice(61), OW
      PUnit(21).SetUnitPos IndexToPos(61).uLine, IndexToPos(61).uColumn
      PUnit(21).SetUnit U_WITE, OFICER
     
     PutUnit frm, Pice(62), HW
      PUnit(22).SetUnitPos IndexToPos(62).uLine, IndexToPos(62).uColumn
      PUnit(22).SetUnit U_WITE, HORSE
     
     PutUnit frm, Pice(63), CW
      PUnit(23).SetUnitPos IndexToPos(63).uLine, IndexToPos(63).uColumn
      PUnit(23).SetUnit U_WITE, CASTLE
       
       For i = 48 To 55
        PutUnit frm, Pice(i), PW
         PUnit(i - 24).SetUnitPos IndexToPos(i).uLine, IndexToPos(i).uColumn
         PUnit(i - 24).SetUnit U_WITE, PAWN
       Next i
      
    Else
    
     PutUnit frm, Pice(0), CW
      PUnit(0).SetUnitPos IndexToPos(0).uLine, IndexToPos(0).uColumn
      PUnit(0).SetUnit U_WITE, CASTLE
     
     PutUnit frm, Pice(1), HW
      PUnit(1).SetUnitPos IndexToPos(1).uLine, IndexToPos(1).uColumn
      PUnit(1).SetUnit U_WITE, HORSE
     
     PutUnit frm, Pice(2), OW
      PUnit(2).SetUnitPos IndexToPos(2).uLine, IndexToPos(2).uColumn
      PUnit(2).SetUnit U_WITE, OFICER
     
     PutUnit frm, Pice(3), KW
      PUnit(3).SetUnitPos IndexToPos(3).uLine, IndexToPos(3).uColumn
      PUnit(3).SetUnit U_WITE, KING
     
     PutUnit frm, Pice(4), QW
      PUnit(4).SetUnitPos IndexToPos(4).uLine, IndexToPos(4).uColumn
      PUnit(4).SetUnit U_WITE, QUEEN
     
     PutUnit frm, Pice(5), OW
      PUnit(5).SetUnitPos IndexToPos(5).uLine, IndexToPos(5).uColumn
      PUnit(5).SetUnit U_WITE, OFICER
     
     PutUnit frm, Pice(6), HW
      PUnit(6).SetUnitPos IndexToPos(6).uLine, IndexToPos(6).uColumn
      PUnit(6).SetUnit U_WITE, HORSE
     
     PutUnit frm, Pice(7), CW
      PUnit(7).SetUnitPos IndexToPos(7).uLine, IndexToPos(7).uColumn
      PUnit(7).SetUnit U_WITE, CASTLE
       
       For i = 8 To 15
        PUnit(i).SetUnitPos IndexToPos(i).uLine, IndexToPos(i).uColumn
        PutUnit frm, Pice(i), PW
        PUnit(i).SetUnit U_WITE, PAWN
       Next i
          
     PutUnit frm, Pice(56), CB
      PUnit(16).SetUnitPos IndexToPos(56).uLine, IndexToPos(56).uColumn
      PUnit(16).SetUnit U_BLACK, CASTLE
     
     PutUnit frm, Pice(57), HB
      PUnit(17).SetUnitPos IndexToPos(57).uLine, IndexToPos(57).uColumn
      PUnit(17).SetUnit U_BLACK, HORSE
     
     PutUnit frm, Pice(58), OB
      PUnit(18).SetUnitPos IndexToPos(58).uLine, IndexToPos(58).uColumn
      PUnit(18).SetUnit U_BLACK, OFICER
     
     PutUnit frm, Pice(59), KB
      PUnit(19).SetUnitPos IndexToPos(59).uLine, IndexToPos(59).uColumn
      PUnit(19).SetUnit U_BLACK, KING
     
     PutUnit frm, Pice(60), QB
      PUnit(20).SetUnitPos IndexToPos(60).uLine, IndexToPos(60).uColumn
      PUnit(20).SetUnit U_BLACK, QUEEN
     
     PutUnit frm, Pice(61), OB
      PUnit(21).SetUnitPos IndexToPos(61).uLine, IndexToPos(61).uColumn
      PUnit(21).SetUnit U_BLACK, OFICER
     
     PutUnit frm, Pice(62), HB
      PUnit(22).SetUnitPos IndexToPos(62).uLine, IndexToPos(62).uColumn
      PUnit(22).SetUnit U_BLACK, HORSE
     
     PutUnit frm, Pice(63), CB
      PUnit(23).SetUnitPos IndexToPos(63).uLine, IndexToPos(63).uColumn
      PUnit(23).SetUnit U_BLACK, CASTLE
       
       For i = 48 To 55
        PutUnit frm, Pice(i), PB
         PUnit(i - 24).SetUnitPos IndexToPos(i).uLine, IndexToPos(i).uColumn
         PUnit(i - 24).SetUnit U_BLACK, PAWN
       Next i
      
    End If
        
End Function

'   
Public Function GetSelectIndex(x As Single, y As Single) As Integer
 
 Dim i As Integer
  '  .
 x = x * Screen.TwipsPerPixelX
 y = y * Screen.TwipsPerPixelY
  '     
 For i = 0 To 63
  DoEvents
  If x >= Pice(i).left And x <= Pice(i).right And y >= Pice(i).top And y <= Pice(i).bottom Then
   GetSelectIndex = i
   Exit For
  End If
 Next i
End Function


Public Function CanMoveUnit(uFrom As Integer, uWeare As Integer) As Boolean
 '   . :(
End Function
 
 ' .    ( ) :)
Public Function IsByse(iline As Integer, icol As Integer) As Boolean

    If (iline > 7 Or iline < 0 Or icol < 0 Or icol > 7) Then Exit Function
    If CDesk(iline, icol) Then IsByse = True Else IsByse = False
    
End Function
'     PUnit
Public Function GetUnitIndex(ByRef iline As Integer, ByRef icol As Integer) As Integer
  Dim i As Integer
      '    . :)
      If (iline > 7 Or iline < 0 Or icol < 0 Or icol > 7) Then Exit Function
     '   
  For i = 0 To 31
   DoEvents
   If iline = PUnit(i).LinePos And icol = PUnit(i).ColPos Then GetUnitIndex = i: Exit For
  Next i

End Function

Public Function SelPice(index As Integer)
  '    :)
  PutUnit frmGame, Pice(index), SM
    
End Function

'Public Function UnselPice()
 ' Dim i As Integer
'  Dim up As UPOS
'   frmGame.Picture = LoadResPicture("desk", 0)
'  For i = 0 To 31
 '  up.uLine = PUnit(i).LinePos
 '  up.uColumn = PUnit(i).ColPos
 '  PutUnit frmGame, Pice(PosToIndex(up)), ClassInfoToRes(PUnit(i).gColor, PUnit(i).gUnit)
 ' Debug.Print "Draw: "; ClassInfoToRes(PUnit(i).gColor, PUnit(i).gUnit)
 ' Next i
 
'End Function


 '    .
Public Function ClassInfoToRes(gColor As String, gUnit As String) As String
 Dim resStr As String
 '       !!!! :)
 Select Case gUnit
 
    Case KING
      resStr = "KING_"
    Case QUEEN
      resStr = "QUEEN_"
    Case OFICER
      resStr = "O_"
    Case HORSE
      resStr = "HORSE_"
    Case PAWN
      resStr = "PAWN_"
    Case CASTLE
      resStr = "CASTLE_"
 End Select
 If gColor = U_WITE Then resStr = resStr & "WITE" Else resStr = resStr & "BLACK"
   ClassInfoToRes = resStr
   
End Function
 ' 
Public Function MoveUnit(up_last As UPOS, up_next As UPOS)
  Dim UnitIndex As Integer
  
  '    
  CDesk(up_last.uLine, up_last.uColumn) = False
  '    
  CDesk(up_next.uLine, up_next.uColumn) = True
   '    
  UnitIndex = GetUnitIndex(up_last.uLine, up_last.uColumn)
   '      
  PUnit(UnitIndex).SetUnitPos up_next.uLine, up_next.uColumn
  
End Function
 '    
Public Function Render(frm As frmGame)
 Dim i As Integer
 Dim up As UPOS
 Dim PiceIndex As Integer
 Dim UResName As String
  
    frm.Picture = LoadResPicture("desk", 0) '  
 For i = 0 To 31
  If Not PUnit(i).IsDie Then
  '    Line X Column
  up.uLine = PUnit(i).LinePos: up.uColumn = PUnit(i).ColPos
  '   
  PiceIndex = PosToIndex(up)
  '    
  UResName = ClassInfoToRes(PUnit(i).gColor, PUnit(i).gUnit)
  '    
  PutUnit frm, Pice(PiceIndex), UResName
  End If
 Next i ' 
End Function
